//
//  Push.h
//  MobeleaderPush
//
//  Created by Mobeleader on 12/01/14.
//  Copyright (c) 2017 Beleader Internet Marketing  S.L. All rights reserved.
//

//To enable this library you need to add the "-ObjC -all_load" flag in the "Build Settings" under "Other Linker Flags"

#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>
#import <AudioToolbox/AudioToolbox.h>
#import <UserNotifications/UserNotifications.h>
#ifdef WITHOUT_AID
    #import <MobeleaderRegisterWithoutAID/MobeleaderRegisterLib.h>
#else
   #import <MobeleaderRegister/MobeleaderRegisterLib.h>
#endif

//Protocol to know what is happening on the library
@protocol PushDelegate
@optional

//Optional function to implement something when the library is going to regsiter the token
//The token variable contains the registered token
-(void)onRegisterToken:(NSString *)token;

//Optional function to implement something when the library is going to update the token
//The token variable contains the updated token
-(void)onUpdateToken:(NSString *)token;

//Optional function to implement something with the actual token
//The token variable contains the actual token
-(void)onGetToken:(NSString *)token;

//Optional function to implement something when the library is has receive a notification
//The notification variable returns the receiver notification information.
//It could have those keys:
//alert --> The alert message
//title --> The tittle of Notification
//type --> The type of  notification for your own use
//extra1 --> The extra parameter for your own use
//extra2 --> The extra parameter for your own use
//extra3 --> The extra parameter for your own use
//extra4 --> The extra parameter for your own use
//extra5 --> The extra parameter for your own use
//For example [notification objectForKey:@"type"]; is the type of the alert

-(void)onReceiveNotification:(NSDictionary *)notification;

//Optional function to show the errors
//The error variable contains the explanation of the error
-(void)onError:(NSString *)error;

@end

//@interface Push : NSObject <UIApplicationDelegate, UNUserNotificationCenterDelegate>

@interface Push : UIResponder <UIApplicationDelegate, UNUserNotificationCenterDelegate>


//Requiered value created in mobeleader website.
@property (nonatomic, retain) NSString *appHash;
@property (assign, nonatomic, readwrite) BOOL deactivateGPS;
    
//Optional value for delegate Push.
@property(nonatomic,assign)id delegate;

+(Push*)shared;

- (NSString *) getVersion;

- (void)activePushNotifications:(BOOL) notifi;

- (void)registerForRemoteNotificationsWithDeviceToken:(NSData *)devToken;

- (void)activePushNotificationsInForegroundApp:(BOOL) active;

- (void)didReceiveRemoteNotification:(NSDictionary *)userInfo;

- (void)application:(UIApplication *)application didReceiveRemoteNotification:(NSDictionary *)userInfo fetchCompletionHandler:(void (^)(UIBackgroundFetchResult result))completionHandler;

- (void)resetBadge;


@end
